﻿var reloadImage = false;
$(document).ready(function () {
    $("#Services").val(defaultValueForServices).trigger("change");

    $("#EditSurveyForm").on("click", ".btn-new-survey-item a", function () {
        var id = $("#SurveyId").val();
        var type = $(this).data("fieldtype");

        $.ajax({
            url: RQ_URL + "/Admin/Surveys/LoadNewQuestion",
            type: "GET",
            data: {
                id: id,
                type: type,
            },
            dataType: "html",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                $("#FormsSurvey").append(g);
                recountField();
                initPlaceHolders();
                initAnswerSortable();
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    });

    $("#dialog-force-delete").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Yes,
                click: function () {
                    DeleteQuestion(forceQuestionId, true);
                    $("#dialog-force-delete").dialog("close");
                }
            }, {
                text: Localization_No,
                click: function () {
                    $("#dialog-force-delete").dialog("close");
                }
            }]
    });

    $("#dialog-force-edit").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                SaveSurveyForce(forceElement);
                $("#dialog-force-edit").dialog("close");
            }
        }, {
            text: Localization_No,
            click: function () {
                $("#dialog-force-edit").dialog("close");
                reloadSurveyQuestion($(forceElement).data("id"), forceElement);
            }
        }]
    });

    $("#dialog-upload-icon").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        close: function (event, ui) {
            $("#dialogIcon").val("");
            if (reloadImage) {
                $("#logoImg").css("background-image", "url(" + RQ_URL + "/Admin/Surveys/GetIcon/" + id + "?v" + Math.floor((Math.random() * 100) + 1) + ")");
            }
        }
    });

    //radio checkbox
    $("#EditSurveyForm").on("click", ".add-button", function () {
        var answers = $(this).closest(".survey-answers");
        var type = $(this).closest(".survey-field").data("fieldtype");
        var inputType = "radio";
        if (type == 2) {
            inputType = "checkbox";
        }
        answers.append("<div class='survey-answer-row'> <a href='javascript:void(0)' class='survey-arrow ui-sortable-handle'><i class='fa fa-arrows' aria-hidden='true'></i></a> " +
            "<input type='" + inputType + "' disabled='disabled' /> <input type='text' class='survey-field-answer'/> " +
            "<button type='button' class='btn btn-secondary btn-xs add-button'><i class='fa fa-plus'></i></button> " +
            "<button type='button' class='btn btn-secondary btn-xs delete-button'><i class='fa fa-minus'></i></button><div class='hidden valid-error'>" +
                "Text odpovědi je povinný" +
            "</div></div>");
        //SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("click", ".delete-button", function () {
        if ($(this).closest(".survey-answers").find(".survey-answer-row").length > 2) {
            $(this).closest(".survey-answer-row").remove();
            SaveSurvey($(this).closest(".survey-field"));
        }
    });

    //Stars
    $("#EditSurveyForm").on("change", ".survey-field-number-of-stars", function () {
        $(this).closest(".survey-field").find(".survey-stars").empty();
        if ($(this).val() < 2) {
            $(this).val("2");
        }
        for (var i = 0; i < $(this).val() ; i++) {
            $(this).closest(".survey-field").find(".survey-stars").append("<i class='fa fa-star-o fa-2x' aria-hidden='true'></i>");
        }
        SaveSurvey($(this).closest(".survey-field"));
    });

    //Matrix radios and checkboxes
    $("#EditSurveyForm").on("click", ".add-button-matrix-column", function () {
        var type = $(this).closest(".survey-field").data("fieldtype");
        $(this).closest(".survey-field").find(".survey-button-matrix-minus").before("<td><button type='button' class='btn btn-secondary btn-xs delete-button-matrix-column'><i class='fa fa-minus'></i></button></td>");
        $(this).closest(".survey-field").find(".survey-button-matrix").before("<td><input type='text' value='' class='survey-field-value' /><div class='hidden valid-error'>Text sloupce je povinný</div></td>");
        if (type == 5) {
            $(this).closest(".survey-field").find(".survey-matrix").before("<td><input type='radio' disabled='disabled' /></td>");
        }
        else {
            $(this).closest(".survey-field").find(".survey-matrix").before("<td><input type='checkbox' disabled='disabled' /></td>");
        }
        //SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("click", ".add-button-matrix-row", function () {
        var count = $(this).closest(".survey-field").find("table tr").first().find("button").length;
        var type = $(this).closest(".survey-field").data("fieldtype");
        var tdGenerated = "";
        for (i = 0; i < count; i++) {
            if (type == 5) {
                tdGenerated += "<td><input type='radio' disabled='disabled' /></td>";
            }
            else {
                tdGenerated += "<td><input type='checkbox' disabled='disabled' /></td>";
            }
        }
        $(this).closest(".survey-field").find("table tr").last().after("<tr><td><a href='javascript:void(0)' class='survey-arrow ui-sortable-handle'><i class='fa fa-arrows' aria-hidden='true'></i></a> <input type='text' class='survey-field-answer'><div class='hidden valid-error'>Text odpovědi je povinný</div></td> " +
            tdGenerated +
            "<td class='survey-matrix'>" +
            "<button type='button' class='btn btn-secondary btn-xs add-button-matrix-row'><i class='fa fa-plus'></i></button> " +
            "<button type='button' class='btn btn-secondary btn-xs delete-button-matrix-row'><i class='fa fa-minus'></i></button>" +
        "</td></tr>");
        //SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("click", ".delete-button-matrix-row", function () {
        if ($(this).closest("table").find("tr").length > 3) {
            $(this).closest("tr").remove();
            SaveSurvey($(this).closest(".survey-field"));
        }
    });

    $("#EditSurveyForm").on("click", ".delete-button-matrix-column", function () {
        if ($(this).closest("tr").find("td").length > 3) {
            var indexOfParent = $(this).closest("td").index();
            $.each($(this).closest(".survey-field").find("table tr"), function (index, value) {
                $(value).find("td:eq(" + indexOfParent + ")").remove();
            });
            SaveSurvey($(this).closest(".survey-field"));
        }
    });

    /// --------------------------------------------------------------------------------------------- 
    $("#EditSurveyForm").on("change", ".survey-field-question", function () {
        SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("change", ".survey-field-own-answer-text", function () {
        SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("change", ".survey-field-help-text", function () {
        SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("change", ".survey-field-required", function () {
        SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("change", ".survey-field-own-answer", function () {
        SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("change", ".survey-field-display-type", function () {
        if ($(this).val() == 3) {
            $(this).closest(".survey-field").find(".survey-field-own-answer").prop("checked", false);
            $(this).closest(".survey-field").find(".survey-field-own-answer").prop("disabled", true);
            $(this).closest(".survey-field").find(".survey-field-own-answer-text").prop("disabled", true);
        }
        else {
            $(this).closest(".survey-field").find(".survey-field-own-answer").prop("disabled", false);
            $(this).closest(".survey-field").find(".survey-field-own-answer-text").prop("disabled", false);
        }
        SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("change", ".survey-field-answer", function () {
        SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("change", ".survey-field-value", function () {
        SaveSurvey($(this).closest(".survey-field"));
    });

    $("#EditSurveyForm").on("click", ".survey-field-delete", function () {
        DeleteQuestion($(this).closest(".survey-field").data("id"), false);
    });

    initPlaceHolders();
    initAnswerSortable();

    $("#EditSurveyForm").on("focusout", "#Title", function () {
        $(this).closest("div").hide();
        $(this).closest(".form-group").find(".survey-title").find("h3").text($(this).val());
        $(this).closest(".form-group").find(".survey-title").show();
        SaveTitle();
    });

    $("#EditSurveyForm").on("click", ".survey-title", function () {
        $(this).hide();
        $(this).closest(".form-group").find(".survey-title-edit").show();
        $(this).closest(".form-group").find(".survey-title-edit").find("input").focus();
    });

    //nastavení
    $(".searchable100Template").select2({
        width: '100%',
        templateSelection: function (service) {
            var name = $('<div/>').html($(service.element).data("name")).text();
            var element = $(service.element).parent();
            while (element.is("option") || element.is("optgroup")) {
                name = $(element).data("name") + "/" + name;
                var element = $(element).parent();
            }
            return name;
        },
    });

    $("#DialogEmailNotification").dialog({
        autoOpen: false,
        resizable: true,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Ok,
            click: function () {
                $("#NotificationSubject").val($("#DialogNotificationSubject").val());
                $("#NotificationTextInHtml").val(tinymce.get("DialogNotificationText").getContent());
                $("#DialogEmailNotification").dialog("close");
                SaveSettings();
            }
        }, {
            Localization_Close: function () {
                $("#DialogEmailNotification").dialog("close");
            }
        }]
    });

    $("#DialogOwnText").dialog({
        autoOpen: false,
        resizable: true,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Ok,
            click: function () {
                $("#TextAfterFilling").val(tinymce.get("DialogTextAfterFilling").getContent());
                $("#DialogOwnText").dialog("close");
                SaveSettings();
            }
        }, {
            Localization_Close: function () {
                $("#DialogOwnText").dialog("close");
            }
        }]
    });

    $("body").on("click", ".survey-own-text", function () {
        tinymce.get("DialogTextAfterFilling").setContent($("#TextAfterFilling").val());
        $("#DialogOwnText").dialog("open");
    });

    $("body").on("click", ".survey-notification", function () {
        $("#DialogNotificationSubject").val($("#NotificationSubject").val());
        tinymce.get("DialogNotificationText").setContent($("#NotificationTextInHtml").val());
        $("#DialogEmailNotification").dialog("open");
    });

    $("#EditSurveySettings").on("change", ".survey-settings-checkbox", function () {
        SaveSettings();
    });

    $("#EditSurveySettings").on("change", ".survey-settings-hours", function () {
        SaveSettings();
    });

    $("#EditSurveySettings").on("change", ".searchable100Template", function () {
        SaveSettings();
    });

    $("#EditSurveySettings").on("change", ".survey-settings-radio", function () {
        SaveSettings();
    });

    $("#EditSurveySettings").on("change", ".survey-settings-notification-subject", function () {
        SaveSettings();
    });

    $("#EditSurveySettings").on("change", "#RedirectToUrl", function () {
        SaveSettings();
    });
});

function openDialogIcon(id) {
    showDeleteButton = $("#logoDiv").attr("data-deletebutton");
    portalItemsIdForDialog = id;
    $("#dialogDeleteIconButton").show();
    if (showDeleteButton != "True") {
        $("#dialogDeleteIconButton").hide();
    }
    $("#dialog-upload-icon").dialog("open");
}

function deleteIcon() {
    $.ajax({
        type: "POST",
        url: RQ_URL + '/Admin/Surveys/DeleteIcon/' + id,
        contentType: false,
        processData: false,
        success: function (result) {
            $("#logoDiv").attr("data-deletebutton", "False");
            $("#logoImg").css("background-color", "lightGray");
            $("#logoImg").text("LOGO");
            reloadImage = true;
            $("#dialog-upload-icon").dialog("close");
        },
        error: function (xhr, status, p3, p4) {
            var err = "Error " + " " + status + " " + p3 + " " + p4;
            if (xhr.responseText && xhr.responseText[0] == "{")
                err = JSON.parse(xhr.responseText).Message;
            console.log(err);
        }
    });
}

function sendFile() {
    $("#FileValidError").hide();
    $("#FileCustomValidError").hide();
    $("#FileValidSizeError").hide();
    var files = $("#dialogIcon").prop("files");
    //var myID = 3; //uncomment this to make sure the ajax URL works
    if (files.length > 0) {
        if (window.FormData !== undefined) {
            var data = new FormData();
            for (var x = 0; x < files.length; x++) {
                data.append("file" + x, files[x]);
            }

            $("#dialogLoadingFiles").show();

            $.ajax({
                type: "POST",
                url: RQ_URL + '/Admin/Surveys/UploadIcon/' + id,
                contentType: false,
                processData: false,
                data: data,
                success: function (result) {
                    $("#dialogLoadingFiles").hide();
                    if (result.success) {
                        $("#logoDiv").attr("data-deletebutton", "True");
                        $("#logoImg").css("background-color", "transparent");
                        $("#logoImg").text("");
                        reloadImage = true;
                        $("#dialog-upload-icon").dialog("close");
                    }
                    else {
                        $("#FileCustomValidError").html(result.message);
                        $("#FileCustomValidError").show();
                    }
                },
                error: function (xhr, status, p3, p4) {
                    var err = "Error " + " " + status + " " + p3 + " " + p4;
                    if (xhr.responseText && xhr.responseText[0] == "{")
                        err = JSON.parse(xhr.responseText).Message;
                    console.log(err);
                    $("#dialogLoadingFiles").hide();
                    $("#FileValidSizeError").show();
                }
            });
        } else {
            alert("This browser doesn't support HTML5 file uploads!");
        }
    }
    else {
        $("#FileValidError").show();
    }
}

function recountField() {
    $.each($(".survey-order-field"), function (index, value) {
        $(value).text(index + 1);
    });
}

function ValidSurvey(element) {
    var result = true;
    $(".valid-error").hide();
    var type = $(element).data("fieldtype");
    if (type == 1 || type == 2) { //radia a checkboxy
        var answers = $(element).find(".survey-field-answer");
        for (var j = 0; j < answers.length; j++) {
            if ($(answers[j]).val() == "") {
                result = false;
                $(answers[j]).focus();
                $(answers[j]).closest(".survey-answer-row").find(".valid-error").show();
            }
        }
        if ($(element).find(".survey-field-own-answer").is(":checked") && $(element).find(".survey-field-own-answer-text").val() == "") {
            result = false;
            $(element).find(".survey-field-own-answer-text").focus();
            $(element).find(".survey-field-own-answer").closest(".row").find(".valid-error").show();
        }
    }
    else if (type == 3 || type == 4) { //text a hvězdy
    }
    else if (type == 5 || type == 6) { //matice 
        var answers = $(element).find(".survey-field-answer");
        for (var j = 0; j < answers.length; j++) {
            if ($(answers[j]).val() == "") {
                result = false;
                $(answers[j]).focus();
                $(answers[j]).closest("td").find(".valid-error").show();
            }
        }
        var values = $(element).find(".survey-field-value");
        for (var j = 0; j < values.length; j++) {
            if ($(values[j]).val() == "") {
                result = false;
                $(values[j]).focus();
                $(values[j]).closest("td").find(".valid-error").show();
            }
        }
    }

    return result;
}

function ValidSettings() {
    var result = true;
    $(".valid-error").hide();
    if ($("#NotificationSubject").val() == "") {
        result = false;
        $("#NotificationSubject").focus();
        $("#NotificationSubject").closest("div").find(".valid-error").show();
    }
    if ($("#CanRedirectToUrl").is(":checked") && $("#RedirectToUrl").val() == "") {
        result = false;
        $("#RedirectToUrl").focus();
        $("#RedirectToUrl").closest("div").find(".valid-error").show();
    }
    if ($("#SendAfterClosureHours").val() == "" || !isInt($("#SendAfterClosureHours").val())) {
        result = false;
        $("#SendAfterClosureHours").focus();
        $("#SendAfterClosureHours").closest("div").find(".valid-error").show();
    }
    return result;
}

function SaveSettings() {
    if (ValidSettings()) {
        $.ajax({
            url: RQ_URL + "/Admin/Surveys/SaveSettings",
            type: "POST",
            data: JSON.stringify({
                id: $("#SurveyId").val(),
                enable: $("#Enabled").is(":checked"),
                manualSend: $("#ManualSend").is(":checked"),
                canSendSurveyAutomatically: $("#CanSendSurveyAutomatically").is(":checked"),
                sendAfterClosureHours: $("#SendAfterClosureHours").val(),
                sendAfterClosureHoursMax: $("#SendAfterClosureHoursMax").val(),
                canUserEdit: $("#CanUserEdit").is(":checked"),
                notificationSubject: $("#NotificationSubject").val(),
                notificationTextInHtml: $('#NotificationTextInHtml').val(),
                canRedirectToUrl: $("#CanRedirectToUrl").is(":checked"),
                redirectToUrl: $("#RedirectToUrl").val(),
                displayTextAfterFilling: $("#DisplayTextAfterFilling").is(":checked"),
                sendAfterReopen: $("#SendAfterReopen").is(":checked"),
                textAfterFilling: $('#TextAfterFilling').val(),
                services: $("#Services").val()
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {

            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    }
}

function isInt(n) {
    return +n === parseInt(n) && !(n % 1);
}

function SaveTitle() {
    $.ajax({
        url: RQ_URL + "/Admin/Surveys/Save",
        type: "POST",
        data: JSON.stringify({
            id: $("#SurveyId").val(),
            title: $("#Title").val(),
            type: 1,
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: function (g) {

        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function SaveIntroductoryText() {
    $.ajax({
        url: RQ_URL + "/Admin/Surveys/Save",
        type: "POST",
        data: JSON.stringify({
            id: $("#SurveyId").val(),
            introductoryText: tinymce.get('IntroductoryText').getContent(),
            type: 2,
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: function (g) {

        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function SaveFooterText() {
    $.ajax({
        url: RQ_URL + "/Admin/Surveys/Save",
        type: "POST",
        data: JSON.stringify({
            id: $("#SurveyId").val(),
            footerText: tinymce.get('FooterText').getContent(),
            type: 3,
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: function (g) {

        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

var forceElement = null;

function SaveSurvey(element) {
    if (ValidSurvey(element)) {
        $.ajax({
            url: RQ_URL + "/Admin/Surveys/SaveQuestion",
            type: "POST",
            data: JSON.stringify({
                id: $("#SurveyId").val(),
                fieldModel: CreateFields(element),
                force: false
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                if (!result) {
                    forceElement = element;
                    $("#dialog-force-edit").dialog("open");
                }
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    }
}

function SaveSurveyForce(element) {
    $.ajax({
        url: RQ_URL + "/Admin/Surveys/SaveQuestion",
        type: "POST",
        data: JSON.stringify({
            id: $("#SurveyId").val(),
            fieldModel: CreateFields(element),
            force: true
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: function (g) {

        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

var forceQuestionId = 0;

function DeleteQuestion(questionId, force) {
    $.ajax({
        url: RQ_URL + "/Admin/Surveys/DeleteQuestion",
        type: "POST",
        data: JSON.stringify({
            id: $("#SurveyId").val(),
            questionId: questionId,
            force: force
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            if (!result) {
                forceQuestionId = questionId;
                $("#dialog-force-delete").dialog("open");
            }
            else {
                $(".survey-field[data-id='" + questionId + "']").remove();
                recountField();
            }
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function CreateFields(element) {
    var type = $(element).data("fieldtype");
    if (type == 1 || type == 2) {
        var answersConverted = new Array();
        var answers = $(element).find(".survey-field-answer");
        for (var j = 0; j < answers.length; j++) {
            answersConverted.push({ Id: $(answers[j]).data("id"), Text: $(answers[j]).val(), Index: j });
        }
        var ownAnswers = $(element).find(".survey-own-anwer-row");
        for (var c = 0; c < ownAnswers.length; c++) {
            answersConverted.push({ OwnAnswer: true, IsSelected: $(ownAnswers[c]).find(".survey-field-own-answer").is(":checked"), Id: $(ownAnswers[c]).data("id"), Text: $(ownAnswers[c]).find(".survey-field-own-answer-text").val(), Index: c });
        }

        return {
            Id: $(element).data("id"),
            Index: $(element).index(),
            Question: $(element).find(".survey-field-question").val(),
            HelpText: $(element).find(".survey-field-help-text").val(),
            Required: $(element).find(".survey-field-required").is(":checked"),
            DisplayType: $(element).find(".survey-field-display-type").val(),
            Answers: answersConverted,
        };
    }
    else if (type == 3) {
        return {
            Id: $(element).data("id"),
            Index: $(element).index(),
            Question: $(element).find(".survey-field-question").val(),
            HelpText: $(element).find(".survey-field-help-text").val(),
            Required: $(element).find(".survey-field-required").is(":checked"),
            DisplayType: $(element).find(".survey-field-display-type").val(),
            Answers: answersConverted,
        };
    }
    else if (type == 4) {
        return {
            Id: $(element).data("id"),
            Index: $(element).index(),
            Question: $(element).find(".survey-field-question").val(),
            HelpText: $(element).find(".survey-field-help-text").val(),
            Required: $(element).find(".survey-field-required").is(":checked"),
            NumberOfStars: $(element).find(".survey-field-number-of-stars").val(),
        }
    }
    else if (type == 5 || type == 6) {
        var answersConverted = new Array();
        var answers = $(element).find(".survey-field-answer");
        for (var j = 0; j < answers.length; j++) {
            answersConverted.push({ Id: $(answers[j]).data("id"), Text: $(answers[j]).val(), Index: j });
        }
        var valuesConverted = new Array();
        var values = $(element).find(".survey-field-value");
        for (var j = 0; j < values.length; j++) {
            valuesConverted.push({ Id: $(values[j]).data("id"), Text: $(values[j]).val(), Index: j });
        }
        return {
            Id: $(element).data("id"),
            Index: $(element).index(),
            Question: $(element).find(".survey-field-question").val(),
            HelpText: $(element).find(".survey-field-help-text").val(),
            Required: $(element).find(".survey-field-required").is(":checked"),
            Answers: answersConverted,
            Values: valuesConverted
        }
    }
}

function reloadSurveyQuestion(id, element) {
    var surveyId = $("#SurveyId").val();
    $.ajax({
        url: RQ_URL + "/Admin/Surveys/ReloadQuestion",
        type: "GET",
        data: {
            id: surveyId,
            questionId: id,
        },
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            element.html(g);
            recountField();
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function surveyClone(id) {
    var surveyId = $("#SurveyId").val();
    $.ajax({
        url: RQ_URL + "/Admin/Surveys/CloneQuestion",
        type: "GET",
        data: {
            id: surveyId,
            surveyFieldId: id,
        },
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            $("#FormsSurvey").append(g);
            recountField();
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function surveyChangeOrder(index, questionId) {
    var surveyId = $("#SurveyId").val();
    $.ajax({
        url: RQ_URL + "/Admin/Surveys/ChangeOrder",
        type: "POST",
        data: JSON.stringify({
            id: surveyId,
            questionId: questionId,
            newIndex: index
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            recountField();
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function userFormat(cellValue, options, rowObject) {
    var userHtml = rowObject.UserFullName != null ? "<a href='javascript:void(0)' class='user-info' data-userproviderkey='" + rowObject.UserProviderKey + "'>" + rowObject.UserFullName + "</a>" : "Neexistuje";
    return userHtml;
}

function initPlaceHolders() {
    position_updated = false; //flag bit

    $("#FormsSurvey").sortable({
        handle: ".survey-field-box-handle",
        items: ".survey-field",
        placeholder: "form-group col-md-offset-1 col-md-11 survey-field-box-placeholder",
        update: function (event, ui) {
            position_updated = !ui.sender; //if no sender, set sortWithin flag to true
        },
        stop: function (event, ui) { //This event is triggered when sorting has stopped.
            recountField();
            surveyChangeOrder($(ui.item[0]).closest(".survey-field").index(), $(ui.item[0]).closest(".survey-field").data("id"));
        },
        receive: function (event, ui) { //This event is triggered when an item from a connected sortable list has been dropped into another list. The latter is the event target.

        },
    });
}

function initAnswerSortable() {
    $(".survey-answers").sortable({
        handle: ".survey-arrow",
        items: ".survey-answer-row",
        stop: function (event, ui) { //This event is triggered when sorting has stopped.
            recountField();
            SaveSurvey($(this).closest(".survey-field"));
        },
    });

    $(".survey-matrix-table").sortable({
        handle: ".survey-matrix-arrow",
        items: "tr",
        stop: function (event, ui) { //This event is triggered when sorting has stopped.
            recountField();
            SaveSurvey($(this).closest(".survey-field"));
        },
    });
}

function addText(constant) {
    tinyMCE.activeEditor.dom.add(tinyMCE.activeEditor.getBody(), 'p', {}, constant);
}