﻿var deleteDashboardId = -1;

$(document).ready(function () {
    $("#DashboardPlace").on("click", ".new-widget", function () {
        $element = $(this);
        $("#dialog-add-new-widget").dialog("open");
    });

    $("#DashboardPlace").on("click", ".fa-trash", function () {
        deleteDashboardId = $(this).closest(".dashboard-item").find(".dashboard-id").val();
        $("#DialogConfirmRemoveDashboardItem").dialog("open");
    });

    $("#DashboardPlace").on("click", ".fa-cog", function () {
        $("#dialog-settings").dialog("open");
        $("#dialog-settings").dialog('option', 'title', $(this).closest(".dashboard-item").find(".title-span").text());
        $("#dialog-settings").html("<div class='loading-32'></div>");
        selectedDashboardItemId = $(this).closest(".dashboard-item").find(".dashboard-id").val();
        selectedType = $(this).closest(".dashboard-item").find(".dashboard-type").val();
        $("#dialog-settings").load(RQ_URL + "/Dashboard/GetSettings/" + selectedDashboardItemId + "?type=" + selectedType, function () {
            SearchableCombos();
            $("#dialog-settings").find(".active > [name='Group']").trigger('change');
            $("#dialog-settings").dialog("close");
            $("#dialog-settings").dialog("open");
        });
    });

    $("#DashboardPlace").on("click", ".dashboard-item .title .title-group.editable-title .title-span", function () {
        $(this).hide();
        $(this).closest(".title").find(".icons").addClass("hidden");
        $(this).closest(".title-group").find(".fa-arrows").addClass("hidden");
        $(this).closest(".title").find(".input-group").removeClass("hidden");
        $(this).closest(".title").find(".input-group input").val($(this).text());
    });

    $("#DashboardPlace").on("click", ".dashboard-item .title .input-group .input-group-btn button", function () {
        if ($(this).closest(".title").find(".input-group input").val() != "") {
            $(this).closest(".title").find(".title-group .title-span").text($(this).closest(".title").find(".input-group input").val());
            $.ajax({
                url: RQ_URL + '/Dashboard/SaveItemName',
                data: {
                    id: $(this).closest(".dashboard-item").find(".dashboard-id").val(),
                    text: $(this).closest(".title").find(".input-group input").val()
                },
                type: "POST"
            });
        }
        $(this).closest(".title").find(".input-group").addClass("hidden");
        $(this).closest(".title").find(".title-group .title-span").show();
        $(this).closest(".title-group").find(".fa-arrows").removeClass("hidden");
        $(this).closest(".title").find(".icons").removeClass("hidden");
    });

    $("#dialog-add-new-widget").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: "700",
        buttons: [{
            text: Localization_Add,
            click: function () {
                var positionInLayout = $element.closest(".dashboard-layout-column").index();
                var positionInCell = $element.closest(".dashboard-layout-column").find(".dashboard-item").length;
                $element.closest('.dashboard-layout-column').find(".dashboard-items").append("<div class='loading-32' data-positioninlayout='"+positionInLayout+"' data-positionincell='"+positionInCell+"'></div>");
                $.ajax({
                    url: RQ_URL + '/Dashboard/GetGraph',
                    data: {
                        dashboardId: selectedDashboard,
                        type: $("#WidgetType").val(),
                        positionInLayout: positionInLayout,
                        positionInCell: positionInCell
                    },
                    type: "POST",
                    dataType: "html",
                    success: function (data) {
                        var pic = $(data).find(".dashboard-position-in-cell").val();
                        var pil = $(data).find(".dashboard-position-in-layout").val();
                        $el = $(".loading-32[data-positioninlayout='" + pil + "'][data-positionincell='" + pic + "']").closest('.dashboard-layout-column');
                        $el.find(".dashboard-items .dashboard-item-add").before(data);
                        $el.find(".dashboard-items > .loading-32[data-positioninlayout='" + pil + "'][data-positionincell='" + pic + "']").remove();
                        initDashboardSorting();
                    },
                });
                $(this).dialog("close");
            }},
            {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-delete-dashboard").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/Dashboard/Delete',
                    data: JSON.stringify({
                        id: selectedDashboard
                    }),
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    success: function (data) {
                        $("#dialog-delete-dashboard").dialog("close");
                        $("#Dashboards option[value='" + selectedDashboard + "']").remove();
                        selectedDashboard = -1;
                        initDashboardSelect2();
                    },
                });
            }
        }, {
            text: Localization_No,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-settings").dialog({
        autoOpen: false,
        resizable: false,
        width: "700",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Save,
            click: function () {
                var data = null;
                $(".active .base-time-count").closest("div").find(".valid-error").hide();
                if ($("[name='TimeSource']:checked").val() == "History" && $(".active .base-time-count").val() == "") {
                    $(".active .base-time-count").closest("div").find(".valid-error").show();
                    return;
                }

                //selectedType - DashboardItemEnum
                if (selectedType == 1) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        Count: $("#TopTagsCount").val(),
                        Source: $("#TopTagsSource").val(),
                    });
                }
                else if (selectedType == 2) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        Group: $("[name='Group']:checked").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        CreatedTickets: $("#NewTicketsCreatedTickets").is(":checked"),
                        ClosedTickets: $("#NewTicketsClosedTickets").is(":checked"),
                        ReopenedTickets: $("#NewTicketsReopenedTickets").is(":checked"),
                    });
                }
                else if (selectedType == 3) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='Scale']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        CreatedTickets: $("#NewTicketsCreatedTickets").is(":checked"),
                        ClosedTickets: $("#NewTicketsClosedTickets").is(":checked"),
                        ReopenedTickets: $("#NewTicketsReopenedTickets").is(":checked"),
                    });
                }
                else if (selectedType == 4) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='PeriodType']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        SelectedPriority: $("#Priority").val(),
                    });
                }
                else if (selectedType == 5) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='PeriodType']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        SelectedSatisfactions: $("#SelectedSatisfactions").val(),
                    });
                }
                else if (selectedType == 6) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='Scale']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        AverageFirstAssignTime: $("#AverageFirstAssignTime").is(":checked"),
                        AverageRepliesTime: $("#AverageRepliesTime").is(":checked"),
                        AverageResolutionTime: $("#AverageResolutionTime").is(":checked"),
                    });
                }
                else if (selectedType == 7) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='Scale']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                    });
                }
                else if (selectedType == 8) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='Scale']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                    });
                }
                else if (selectedType == 9) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='Group']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                    });
                }
                else if (selectedType == 10) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        Count: $("#Top").val(),
                        ClosedTickets: $("#IncludeClosedTickets").is(":checked"),
                    });
                }
                else if (selectedType == 11) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        ClosedTickets: $("#IncludeClosedTickets").is(":checked"),
                    });
                }
                else if (selectedType == 12) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='Group']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                    });
                }
                else if (selectedType == 13) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        Group: $("[name='Group']:checked").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        Top: $("#NewTicketsBySolverTop").val(),
                    });
                }
                else if (selectedType == 14) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        Count: $("#Top").val(),
                        ClosedTickets: $("#IncludeClosedTickets").is(":checked"),
                    });
                }
                else if (selectedType == 15) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        Group: $("[name='Group']:checked").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        Top: $("#NewTicketsByCustomerTop").val(),
                    });
                }
                else if (selectedType == 16) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        SelectedSlas: $("#Slas").val(),
                        ShowType: $("[name='ShowType']:checked").val(),
                    });
                }
                else if (selectedType == 17) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        Group: $("[name='Scale']:checked").val(),
                        ChartType: $("#NewTicketsChart").val(),
                    });
                }
                else if (selectedType == 18) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        Count: $("#TopCategoryItemsCount").val(),
                        Source: $("#TopCategoryItemsSource").val(),
                        SelectedCategory: $("#TopCategoryItemsCategoryId").val(),
                        SelectedServices: $("#TopCategoryItemsServices").val(),
                    });
                }
                else if (selectedType == 19) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        Group: $("[name='Group']:checked").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        ChartType: $("#CategoryItemsTimeChart").val(),
                        SelectedCategory: $("#CategoryItemsTimeCategoryId").val(),
                        Top: $("#CategoryItemsTimeTop").val(),
                    });
                }
                else if (selectedType == 20) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        Group: $("[name='Group']:checked").val(),
                        ChartType: $("#NumberOfCallsTimeChart").val(),
                    });
                }
                else if (selectedType == 21) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        Group: $("[name='Group']:checked").val(),
                        ChartType: $("#NumberOfRequestWithCallTimeChart").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                    });
                }
                else if (selectedType == 22) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedChatProfiles: $("#SelectedChatProfiles").val()
                    });
                }
                else if (selectedType == 23) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedChatProfiles: $("#SelectedChatProfiles").val(),
                        Group: $("[name='Scale']:checked").val(),
                        BoolOption1: $("[name='FulfilledChats']:checked").val(),
                        BoolOption2: $("[name='MissedChats']:checked").val(),
                        BoolOption3: $("[name='AllChats']:checked").val()
                    });
                }
                else if (selectedType == 24) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedChatProfiles: $("#SelectedChatProfiles").val(),
                        SelectedOperators: $("#SelectedOperators").val(),
                        SelectedOperatorGroups: $("#SelectedOperatorGroups").val(),
                        Ascending: $("#NumberOfChatsByOperatorsAscending:checked").val(),
                        Top: $("#NumberOfChatsByOperatorsTop").val()
                    });
                }
                else if (selectedType >= 25 && selectedType <= 28 || selectedType == 31) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedChatProfiles: $("#SelectedChatProfiles").val(),
                        SelectedOperators: $("#SelectedOperators").val(),
                        SelectedOperatorGroups: $("#SelectedOperatorGroups").val(),
                        Group: $("[name='Scale']:checked").val(),
                        ChartType: $("#ChatChartType").val(),
                        BoolOption1: $("[name='Average']:checked").val(),
                        BoolOption2: $("[name='Max']:checked").val(),
                        BoolOption3: $("[name='Min']:checked").val()
                    });
                }
                else if (selectedType == 30) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedChatProfiles: $("#SelectedChatProfiles").val(),
                        SelectedOperators: $("#SelectedOperators").val(),
                        SelectedOperatorGroups: $("#SelectedOperatorGroups").val(),
                        Group: $("[name='Scale']:checked").val()
                    });
                }
                else if (selectedType == 29) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedChatProfiles: $("#SelectedChatProfiles").val(),
                        Group: $("[name='Scale']:checked").val()
                    });
                }
                else if (selectedType == 32) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        SelectedProducts: $("#SelectedProducts").val(),
                    });
                }
                else if (selectedType == 33) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        SelectedCategories: $("#SelectedCategories").val(),
                    });
                }
                else if (selectedType == 34) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        Group: $("[name='Group']:checked").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        ChartType: $("#NewTicketsChart").val(),
                        SelectedProducts: $("#SelectedProducts").val(),
                    });
                }
                else if (selectedType == 35) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Timespan: $("#Timespan").val(),
                        Group: $("[name='Group']:checked").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        ChartType: $("#NewTicketsChart").val(),
                    });
                }
                else if (selectedType == 36) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='PeriodType']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        SelectedProducts: $("#SelectedProducts").val(),
                        SelectedCategories: $("#SelectedCategories").val(),
                    });
                }
                else if (selectedType == 37) {
                    data = JSON.stringify({
                        Type: selectedType,
                        Id: selectedDashboardItemId,
                        TimeSource: $("[name='TimeSource']:checked").val(),
                        TimePeriod: $("[name='TimePeriod']:checked").val(),
                        HistoryTimePeriod: $("[name='HistoryTimePeriod']:checked").val(),
                        Count: $(".active .base-time-count").val(),
                        Group: $("[name='PeriodType']:checked").val(),
                        Timespan: $("#Timespan").val(),
                        SelectedServices: $("#NewTicketsServices").val(),
                        SelectedCustomers: $("#NewTicketsCompanies").val(),
                        SelectedCategories: $("#SelectedCategories").val(),
                    });
                }
                $.ajax({
                    url: RQ_URL + '/Dashboard/SaveSettings',
                    data: data,
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    success: function (data) {
                        $("#dialog-settings").dialog("close");
                        reloadGraph(selectedDashboardItemId);
                    },
                });
                $(this).dialog("close");
            }
        }, {
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-new-dashboard").dialog({
        autoOpen: false,
        resizable: false,
        width: "800",
        height: "auto",
        modal: true,
        buttons: [{
            id: 'DashboardSave',
            text: Localization_Save,
            click: function () {
                $(".valid-error").hide();
                if ($("#Name").val() == "") {
                    $("#Name").parent().find(".valid-error").show();
                }
                else {
                    $.ajax({
                        url: RQ_URL + '/Dashboard/CreateOrUpdate',
                        data: JSON.stringify({
                            IsNew: $("#IsNew").val(),
                            Id: $("#Id").val(),
                            Name: $("#Name").val(),
                            Color: $("#ColorValue").val(),
                            LayoutType: $("input[name='LayoutType']:checked").val(),
                            ShareType: $("input[name='ShareType']:checked").val(),
                            AllOperators: $("#AllOperators").is(":checked"),
                            AllUsers: $("#AllUsers").is(":checked"),
                            RestrictVisibility: $("#RestrictVisibility").is(":checked"),
                            SelectedOperatorGroups: $("#SelectedOperatorGroups").val(),
                            SelectedInternalGroups: $("#SelectedInternalGroups").val(),
                            SelectedCustomers: $("#SelectedCustomers").val(),
                            SelectedUsers: $("#SelectedUsers").val(),
                            UniqueEnable: $("#PublicShare").is(":checked")
                        }),
                        type: "POST",
                        contentType: "application/json; charset=utf-8",
                        success: function (data) {
                            $("#dialog-new-dashboard").dialog("close");
                            if ($("#IsNew").val() == "True") {
                                $("#Dashboards").append("<option data-ismy='True' data-color='" + $("#ColorValue").val() + "' value='" + data + "'>" + $("#Name").val() + "</option>");
                                $("#Dashboards").val(data).trigger("change");
                            }
                            else {
                                $("#Dashboards option[value='" + data + "']").data("color", $("#ColorValue").val());
                                $("#Dashboards option[value='" + data + "']").text($("#Name").val());
                            }
                            initDashboardSelect2();
                        },
                    });
                }
            }
        }, {
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#PublicShare").change(function () {
        $("#DashboardLink").toggle($(this).is(":checked"));
        if ($(this).is(":checked")) {
            $.ajax({
                url: RQ_URL + '/Dashboard/GetUniqueId',
                data: {
                    Id: selectedDashboard,
                },
                type: "GET",
                contentType: "application/json; charset=utf-8",
                success: function (event) {
                    $("#DashboardUniqueId").val(event.id);
                    $("#DashboardLink").html("<a href='" + event.url + "'><small>" + event.url + "</small></a>");
                },
            });
        }
        else {
            $.ajax({
                url: RQ_URL + '/Dashboard/SetDashboardUnique',
                data: JSON.stringify({
                    id: selectedDashboard,
                    value: $(this).is(":checked")
                }),
                type: "POST",
                contentType: "application/json; charset=utf-8",
                success: function (event) {
                },
            });
        }
    });

    $("#DialogConfirmRemoveDashboardItem").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/Dashboard/RemoveItem',
                    data: {
                        id: deleteDashboardId,
                    },
                    type: "POST"
                });
                $(".dashboard-id[value='" + deleteDashboardId + "']").closest(".dashboard-item").remove();
                $("#DialogConfirmRemoveDashboardItem").dialog("close");
            }
        }, {
            text: Localization_No,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });
    
    initDashboardSelect2();
    $('#Color').initColorpicker();

    $("input[name='DashboardShare']").change(function () {
        alert('test');
        $("#AllOperators").prop("disabled", $("#Private").is(":checked"));
        $("#AllUsers").prop("disabled", $("#Private").is(":checked"));
        $("#RestrictVisibility").prop("disabled", $("#Private").is(":checked"));
        $("#PublicShare").prop("disabled", $("#Private").is(":checked"));
        $("#SelectedOperatorGroups").prop("disabled", $("#Private").is(":checked"));
        $("#SelectedInternalGroups").prop("disabled", $("#Private").is(":checked"));
        $("#SelectedCustomers").prop("disabled", $("#Private").is(":checked"));
        $("#SelectedUsers").prop("disabled", $("#Private").is(":checked"));
        if ($("#Private").is(":checked")) {
            $("#DashboardLink").html("");
        }
        else {
            $("#PublicShare").trigger("change");
        }
    });

    $('#DashboardPlace').on('click', ".dashboard-item .title .fa-arrows-alt", function () {
        if (screenfull.enabled) {
            $dashboard_item = $(this).closest('.dashboard-item');
            var target = $dashboard_item[0]; // Get DOM element from jQuery collection
            screenfull.toggle(target);
        }
    });

    $("#dialog-settings").on('change', "[name='Group']", function () {
        $("[name='TimePeriod'][value='ThisDay']").closest("a").prop("disabled", false);
        $("[name='TimePeriod'][value='ThisWeek']").closest("a").prop("disabled", false);
        $("[name='TimePeriod'][value='ThisMonth']").closest("a").prop("disabled", false);
        $("[name='TimePeriod'][value='ThisQuarter']").closest("a").prop("disabled", false);
        if ($(this).val() == "Week") {
            if ($("[name='TimePeriod'][value='ThisDay']").is(":checked")) {
                $("[name='TimePeriod'][value='ThisWeek']").prop("checked", true).trigger("change");
                $("[name='TimePeriod'][value='ThisWeek']").closest("a").trigger("click");
            }
            $("[name='TimePeriod'][value='ThisDay']").closest("a").prop("disabled", true);
        }
        else if ($(this).val() == "Month") {
            if ($("[name='TimePeriod'][value='ThisDay']").is(":checked") || $("[name='TimePeriod'][value='ThisWeek']").is(":checked")) {
                $("[name='TimePeriod'][value='ThisMonth']").prop("checked", true).trigger("change");
                $("[name='TimePeriod'][value='ThisMonth']").closest("a").trigger("click");
            }
            $("[name='TimePeriod'][value='ThisDay']").closest("a").prop("disabled", true);
            $("[name='TimePeriod'][value='ThisWeek']").closest("a").prop("disabled", true);
        }
        else if ($(this).val() == "Quarter") {
            if ($("[name='TimePeriod'][value='ThisDay']").is(":checked") || $("[name='TimePeriod'][value='ThisWeek']").is(":checked")
                || $("[name='TimePeriod'][value='ThisMonth']").is(":checked")) {
                $("[name='TimePeriod'][value='ThisQuarter']").prop("checked", true).trigger("change");
                $("[name='TimePeriod'][value='ThisQuarter']").closest("a").trigger("click");
            }
            $("[name='TimePeriod'][value='ThisDay']").closest("a").prop("disabled", true);
            $("[name='TimePeriod'][value='ThisWeek']").closest("a").prop("disabled", true);
            $("[name='TimePeriod'][value='ThisMonth']").closest("a").prop("disabled", true);
        }
        else if ($(this).val() == "Year") {
            if ($("[name='TimePeriod'][value='ThisDay']").is(":checked") || $("[name='TimePeriod'][value='ThisWeek']").is(":checked")
                || $("[name='TimePeriod'][value='ThisMonth']").is(":checked") || $("[name='TimePeriod'][value='ThisQuarter']").is(":checked")) {
                $("[name='TimePeriod'][value='ThisYear']").prop("checked", true).trigger("change");
                $("[name='TimePeriod'][value='ThisYear']").closest("a").trigger("click");
            }
            $("[name='TimePeriod'][value='ThisDay']").closest("a").prop("disabled", true);
            $("[name='TimePeriod'][value='ThisWeek']").closest("a").prop("disabled", true);
            $("[name='TimePeriod'][value='ThisMonth']").closest("a").prop("disabled", true);
            $("[name='TimePeriod'][value='ThisQuarter']").closest("a").prop("disabled", true);
        }
    });

});

var selectedDashboard = -1;

function reloadGraph(dashboardItemId) {
    var $el = $(".dashboard-id[value='" + dashboardItemId + "']").closest(".dashboard-item");
    if ($el.find(".loading-32").length == 0) {
        $el.find(".dashboard-graph").prepend("<div class='loading-32'></div>");
    }
    $.ajax({
        url: RQ_URL + "/Dashboard/ReloadGraph/" + dashboardItemId,
        dataType: "html",
        success: function (data) {
            $el.find(".dashboard-graph").html(data);
        },
    });
}

function editDialog(type) {
    $("#DashboardSave span").text(Localization_Save);
    $("#dialog-new-dashboard").html("<div class='loading-32'></div>");
    $('#dialog-new-dashboard').dialog('option', 'title', Localization_Dashboard_EditDashboard);
    $("#dialog-new-dashboard").dialog("open");
    $("#dialog-new-dashboard").load(RQ_URL + '/Dashboard/Get/' + selectedDashboard, function () {
        $("#SelectedUsers").val(selectedUsers);
        $("#SelectedUsers").trigger('change');
        $("#dialog-new-dashboard").dialog("close");
        $("#dialog-new-dashboard").dialog("open");
        $("#tabA a").tab('show');
    });
}

function openDeleteDialog() {
    $("#dialog-delete-dashboard").dialog("open");
}

var sendingTimer;
var intervalForTimer = 1000;

function setTimer() {
    $("#DashboardPlace").html("<div class='loading-32'></div>");
    clearTimeout(sendingTimer);
    sendingTimer = setTimeout(loadDashboard, intervalForTimer);
}

function loadDashboard() {
    $("#DashboardPlace").load(RQ_URL + "/Dashboard/Show/" + selectedDashboard);
}

function clone() {
    $.ajax({
        url: RQ_URL + '/Dashboard/Clone',
        data: JSON.stringify({
            Id: selectedDashboard,
        }),
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
            realodDashboards(data);
        },
    });
}

function realodDashboards(data) {
    $("#DashboardSelect").load(RQ_URL + "/Dashboard/ReloadDashboards", function () {
        $("#Dashboards").val(data).trigger("change");
    });
}

function setFavorite() {
    $.ajax({
        url: RQ_URL + '/Dashboard/Favorite',
        data: JSON.stringify({
            Id: selectedDashboard,
        }),
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {

        },
    });
}

function initDashboardSelect2() {
    $(".dashboardSelect2").select2({
        width: '100%',
        templateResult: formatDashboardState,
        templateSelection: formatDashboardState,
        placeholder: Localization_SelectInSelect,
    }).change(function () {
        if ($("#Dashboards").val() == "" || $("#Dashboards").val() == null) {
            $(".dashboard-action").closest("div").hide();
            $("#DashboardPlace").empty();
            $("#EmptyMessage").show();
            $("#Dashboards").closest("div").hide();
        }
        else {
            $("#Dashboards").closest("div").show();
            $("#EmptyMessage").hide();
            $(".dashboard-action").closest("div").show();
            selectedDashboard = $("#Dashboards").val();
            setTimer();
            if ($("#Dashboards option:selected").data("ismy") == "True" || isAdministrator) {
                $(".dashboard-action").prop("disabled", false);
            }
            else {
                $(".dashboard-action").prop("disabled", true);
            }
        }
    });
    $(".dashboardSelect2").trigger("change");
}

function formatDashboardState(state) {
    if (!state.id) { return state.text; }
    var $state = $(
      '<span style="font-size:18px;"><i style="color:' + $(state.element).data("color") + '" class="fa fa-fw fa-tachometer" aria-hidden="true"></i> <strong>' + state.text + '</strong></span>'
    );
    return $state;
}

function openDialog() {
    $("#DashboardSave span").text(Localization_Create);
    $("#dialog-new-dashboard").html("<div class='loading-32'></div>");
    $('#dialog-new-dashboard').dialog('option', 'title', Localization_Dashboard_NewDashboard);
    $("#dialog-new-dashboard").dialog("open");
    $("#dialog-new-dashboard").load(RQ_URL + '/Dashboard/GetNewPartial', function () {
        $("#dialog-new-dashboard").dialog("close");
        $("#dialog-new-dashboard").dialog("open");
        $("#tabA a").tab('show');
    });
}

function formatWidgetState(state) {
    if (!state.id) { return state.text; }
    var $state = $('<span style="font-size:18px;"><img src="Content/img/widget.svg" width="16px" height="16px" /> <strong>' + state.text + '</strong></span>');
    return $state;
}

function formatWidgetStateWithDescription(state) {
    if (!state.id) { return state.text; }
    var title = $(state.element).data("title");
    var $state = $('<span style="font-size:18px;"><img src="Content/img/widget.svg" width="16px" height="16px" /> <strong>' + state.text + '</strong></span><div style="color: #838d93;padding-left:24px;"><span>' + title + '</span></div>');
    return $state;
}

function initDashboardSorting() {
    $(".dashboard-items").sortable({
        items: ".dashboard-item",
        connectWith: ".dashboard-items",
        handle: ".fa-arrows",
        placeholder: "dashboard-item-placeholder",
        remove: function (event, ui) { //This event is triggered when a sortable item from the list has been dropped into another. The former is the event target.
            if ($(this).closest(".dashboard-items").find(".dashboard-item").length > 0) {
                ids = $(this).closest(".dashboard-layout-column").find(".dashboard-id").map(function () {
                    return $(this).val();
                }).get();
                $.ajax({
                    url: RQ_URL + '/Dashboard/ChangePositions',
                    data: {
                        ids: ids,
                        positionInLayout: $(this).closest(".dashboard-layout-column").index(),
                    },
                    type: "POST"
                });
            }
        },
        stop: function (event, ui) {
            var ids = $(ui.item).closest(".dashboard-layout-column").find(".dashboard-id").map(function () {
                return $(this).val();
            }).get();
            $.ajax({
                url: RQ_URL + '/Dashboard/ChangePositions',
                data: {
                    ids: ids,
                    positionInLayout: $(ui.item).closest(".dashboard-layout-column").index(),
                },
                type: "POST"
            });

            var $column = $(ui.item).closest(".dashboard-layout-column");
            $column.find('.dashboard-item-add').remove().insertAfter($column.find(".dashboard-items .dashboard-item:last")); //aby bylo posledni tl. pro pridani
        },
    });
}

function fullScreen() {

    var target = $('#DashboardPlace')[0];
    if (screenfull.enabled) {
        screenfull.toggle(target);
    }
}

var $dashboard_item = null;

if (typeof screenfull !== 'undefined' && screenfull.enabled) {
    document.addEventListener(screenfull.raw.fullscreenchange, function () {
        //alert(screenfull.element.id + ' c: ' + screenfull.element.className);
        if (screenfull.element != null) {
            if (screenfull.element.id == 'DashboardPlace') {
                if (screenfull.isFullscreen) {
                    $('#DashboardPlace').addClass("fullscreen");
                }
            }
            else if (screenfull.element.className == 'dashboard-item' && $dashboard_item != null) {
                if (screenfull.isFullscreen) {
                    $dashboard_item.addClass('chart-fullscreen');
                    var $chart = $dashboard_item.find('.dashboard-graph > div[data-highcharts-chart]');
                    if ($chart.length) {
                        $chart.highcharts().reflow();
                    }
                }
            }
        }
        else {
            if (!screenfull.isFullscreen) {
                $('#DashboardPlace').removeClass("fullscreen");
                if ($dashboard_item != null) {
                    $dashboard_item.removeClass('chart-fullscreen');
                    var $chart = $dashboard_item.find('.dashboard-graph > div[data-highcharts-chart]');
                    if ($chart.length) {
                        $chart.highcharts().reflow();
                    }
                    $dashboard_item = null;
                }
            }
        }

    });
}

$.fn.initColorpicker = function () {
    $(this).colorpicker({
        colorSelectors: {
            '#FAF6BD': '#FAF6BD',
            '#C4E2B8': '#C4E2B8',
            '#AFE0EC': '#AFE0EC',
            '#CFBCDC': '#CFBCDC',
            '#F4C0CB': '#F4C0CB',
            '#FAFAFA': '#FAFAFA',
        }
    })
        .on('changeColor', function (event) {
            var color = event.color;
            color.a = '0.9';
            if ($(event.target).attr("id") == "BackgroundColor") {
                $(".circle-display-style").css("background", $("#BackgroundColorValue").val());
                $(".rectangle-display-style").css("background", $("#BackgroundColorValue").val());
            }
            else {
                $(".circle-display-style").css("color", $("#FontColorValue").val());
                $(".rectangle-display-style").css("color", $("#FontColorValue").val());
            }
        })
        .on('hidePicker', function (event) {
        });
};

function secondsToHumanizedTime(time) {
    var minutes = Math.floor(time / 60);
    var seconds = time - minutes * 60;
    return (minutes < 10 ? "0" : "") + minutes + ":" + (seconds < 10 ? "0" : "") + seconds;
}

Highcharts.dateFormats = {
    W: function (timestamp) {
        var date = new Date(timestamp),
            day = date.getUTCDay() === 0 ? 7 : date.getUTCDay(),
            dayNumber;
        date.setDate(date.getUTCDate() + 4 - day);
        dayNumber = Math.floor((date.getTime() - new Date(date.getUTCFullYear(), 0, 1, -6)) / 86400000);
        return 1 + Math.floor(dayNumber / 7);

    }
};