﻿'use strict';

var urlUtils = (function () {
    function getUrlPathArray(str) {
        str = (str || window.location.pathname).replace(/(^\?)/, '');
        var indexOfPathEnd = str.indexOf('?');
        if (indexOfPathEnd === -1)
            indexOfPathEnd = str.indexOf('#');

        return (indexOfPathEnd >= 0 ? str.substring(0, indexOfPathEnd) : str).split('/');
    }

    function getQueryParameters(str) {
        return (str || window.location.search).replace(/(^\?)/, '').split("&").map(function (n) { return n = n.split("="), this[n[0]] = n[1], this }.bind({}))[0];
    }

    function updateQueryParameter(key, value, url) {
        if (!url) url = window.location.href;
        var re = new RegExp("([?&])" + key + "=.*?(&|#|$)(.*)", "gi"),
            hash;

        if (re.test(url)) {
            if (typeof value !== 'undefined' && value !== null)
                return url.replace(re, '$1' + key + "=" + value + '$2$3');
            else {
                hash = url.split('#');
                url = hash[0].replace(re, '$1$3').replace(/(&|\?)$/, '');
                if (typeof hash[1] !== 'undefined' && hash[1] !== null)
                    url += '#' + hash[1];
                return url;
            }
        }
        else {
            if (typeof value !== 'undefined' && value !== null) {
                var separator = url.indexOf('?') !== -1 ? '&' : '?';
                hash = url.split('#');
                url = hash[0] + separator + key + '=' + value;
                if (typeof hash[1] !== 'undefined' && hash[1] !== null)
                    url += '#' + hash[1];
                return url;
            }
            else
                return url;
        }
    }

    return {
        getUrlPathArray: getUrlPathArray,
        getQueryParameters: getQueryParameters,
        updateQueryParameter: updateQueryParameter
    };
})();